unit Unit1;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, EditBtn, FileUtil;

type

  { TForm1 }

  TForm1 = class(TForm)
    DirectoryEdit1: TDirectoryEdit;
    Panel1: TPanel;
    Splitter1: TSplitter;
    TreeView1: TTreeView;
    Button2: TButton;
    procedure DirectoryEdit1Change(Sender: TObject);
    function TVSearch(aTreeView:TTreeView; aSearchString:String):boolean;
    function GetChangeDate(aFile:string):string;
    procedure Button2Click(Sender: TObject);
    procedure ChildNodesCount;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  aFiles:TStringList;

implementation

{$R *.lfm}

function TForm1.GetChangeDate(aFile:string):string;
begin
 Result:=FormatDateTime('dd.mm.yyyy', FileDateToDateTime(FileAge(aFile)));
end;

function TForm1.TVSearch(aTreeView:TTreeView; aSearchString:String):boolean;
 var
  i:integer;
 begin
  Result:= false;
  for i:=0 to aTreeView.Items.Count-1 do
   begin
    if Pos(aSearchString, aTreeView.Items[i].Text)>0 then
     begin
      aTreeView.Selected := aTreeView.Items[i];
      aTreeView.SetFocus;
      Result:= true;
     end;
    end;
   end;

procedure TForm1.DirectoryEdit1Change(Sender: TObject);
begin
  aFiles:=TStringList.Create;
  aFiles := FindAllFiles(DirectoryEdit1.Directory, '*.*', true);
end;

procedure TForm1.ChildNodesCount;
 var
  I: integer;
 begin
  for I := 0 to TreeView1.Items.Count-1 do
  begin
    if TreeView1.Items.Item[i].HasChildren=true then
      TreeView1.Items.Item[i].Text:= TreeView1.Items.Item[i].Text+
      ' ('+IntToStr(TreeView1.Items.Item[i].Count)+')';
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
 var
  NodeFind:Boolean;
  I:Integer;
  aDate:String;
 begin
  for I:= 0 to aFiles.Count-1 do
   begin
    aDate:= GetChangeDate(aFiles.Strings[i]);
      if TreeView1.Items.Count>0 then
       begin
        NodeFind:= TVSearch(TreeView1, aDate);
         if NodeFind then
           begin
            TreeView1.Items.AddChild(TreeView1.Selected, aFiles.Strings[i]);
           end else
           begin
            TreeView1.Items.Add(nil, aDate);
            NodeFind:= TVSearch(TreeView1, aDate);
            TreeView1.Items.AddChild(TreeView1.Selected, aFiles.Strings[i]);
           end;
       end else
       begin
        TreeView1.Items.Add(nil, aDate);
        TreeView1.Items.Item[i].Selected:=True;
        TreeView1.Items.AddChild(TreeView1.Selected, aFiles.Strings[i]);
       end;
   end;
  ChildNodesCount;
 end;

end.



function SuperFindAllFiles(const SearchPath: String; SearchMask: String = '';
  SearchSubDirs: Boolean = True; DirAttr: Word = faDirectory): TStringList; overload;
var
  i : integer;
  p : integer;
begin
  Result:=FindAllFiles(SearchPAth, SearchMask, SearchSubDirs, DirAttr);
  if Assigned(Result) then begin
    p:=length(IncludeTrailingPathDelimiter(SearchPath))+1;
    for i:=0 to Result.Count-1 do
      Result[i]:=Copy(Result[i], p, maxint);
  end;
end;


































